#include<fstream>    
#include<iostream> 

// (*) include lexical analyser header
#include "quex_turtle_TurtleLexer"
#include <quex/code_base/bom>
#include <quex/code_base/bom.i>
#include "TurtleParser.h"

#ifndef     ENCODING_NAME
#    define ENCODING_NAME (0x0)
#endif

using namespace sparkledb::sdbms::processor::lexers;

int main(int argc, char** argv) 
{        
	CTurtleParser *turtleParser = new CTurtleParser();
	turtleParser->OnlyCalledFunction();

	std::cout << "Done" << std::endl;
	int key = getchar();
	return 0;
}

int oldMain()
{
    turtle::Token* token_p = 0x0;
    // (*) create the lexical analyser
    //     1st arg: input file, default = 'example.txt'
    //     2nd arg: input character encoding name, 0x0 --> no codec conversion
    //FILE* fh = fopen(argc > 1 ? argv[1] : "test1.ttl", "rb");
    FILE* fh = _wfopen(L"test1.ttl", L"rb");

    /* Either there is no BOM, or if there is one, then it must be UTF8 */
    QUEX_TYPE_BOM bom_type = quex::bom_snap(fh);

    std::cout << "Found BOM: " << quex::bom_name(bom_type) << std::endl;

    if( (bom_type & (QUEX_BOM_UTF_8 | QUEX_BOM_NONE)) == 0 ) {
        std::cout << "Found a non-UTF8 BOM. Exit\n";
        fclose(fh);
        return 0;
    }

    /* The lexer **must** be constructed after the BOM-cut */
    quex::turtle::TurtleLexer *qlex = new quex::turtle::TurtleLexer(fh, "UTF8");

    //cout << ",-----------------------------------------------------------------\n";
    //cout << "| [START]\n";

    //int number_of_tokens = 0;

	qlex->buffer_input_pointer_set(qlex->buffer_lexeme_start_pointer_get());

    // (*) loop until the 'termination' token arrives
    do {
        // (*) get next token from the token stream
        qlex->receive(&token_p);

        // (*) print out token information
        std::cout << "(" << token_p->line_number() << ", " << token_p->column_number() << ")  \t";
        std::cout << "Token=\"" << token_p->pretty_char_text() << "\"" << std::endl; 
        //cout << string(*token_p) << std::endl; 

        //++number_of_tokens;

        // (*) check against 'termination'
    } while( token_p->type_id() != QUEX_TKN_TERMINATION );

    //cout << "| [END] number of token = " << number_of_tokens << "\n";
    //cout << "`-----------------------------------------------------------------\n";

	fclose(fh);

	int key = getchar();

    return 0;
}
